#include "main.h"
#include <stdio.h>
#include <limits.h>

#define FALSE   0
#define TRUE    (!FALSE)


#define LEFT    0
#define RIGHT   1
#define UP      2
#define DOWN    3

#define THRESHOLD 100

#define STACK_SIZE ((MEM_WIDTH * MEM_HEIGHT) + 10)

typedef struct pos
{
    int x;
    int y;
}   POS;

/*#define stack_empty() ( stack_index == -1 )*/
#define stack_empty() ( ((qrear + 1) % STACK_SIZE) == qfront )
/*#define stack_full()  ( stack_index >= max_stack_index )*/
#define stack_full() ( ((qrear + 2) % STACK_SIZE) == qfront )

#define is_empty( x ) ( ( (x) == PLAIN ) || ( (x) == HOME ) )


POS *stack = NULL;
long stack_index, max_stack_index;

long qrear = -1, qfront = 0;


int push( POS pos )
{
    if ( stack_full() )
    {
        return FALSE;
    }

    /*stack[++stack_index] = pos;*/
    qrear = (qrear + 1) % STACK_SIZE;
    stack[qrear] = pos;

    return TRUE;
}

int pop( POS *pos )
{
    if ( stack_empty() )
    {
        return FALSE;
    }

    /* *pos = stack[stack_index--]; */

    *pos = stack[qfront];
    qfront = (qfront + 1) % STACK_SIZE;

    return TRUE;
}


void ShortestPath (int xOrigin, int yOrigin )
{
    int x, y;
    POS pos, neigh_pos;
    long len, temp_len;
    char status;
    int dir;


    for ( y = 0; y < MEM_HEIGHT; y++ )
    {
        for ( x = 0; x < MEM_WIDTH; x++ )
        {
            Tile(x, y ).pathVal = MAX_LEN;
        }
    }

    if ( stack == NULL )
    {
        stack = (POS *)malloc( STACK_SIZE * sizeof(POS) );
        if ( stack == NULL )
        {
            return;
        }
    }

    stack_index = -1;
    max_stack_index = STACK_SIZE - 1;

    qrear = -1;
    qfront = 0;


    pos.x = xOrigin;
    pos.y = yOrigin;

    Tile( pos.x, pos.y ).pathVal = 0;

    push( pos );

    while ( !stack_empty() )
    {
        pop( &pos );
        len = Tile( pos.x, pos.y ).pathVal + 1;
/*
	if(!(len + 1 < THRESHOLD))
	{
		continue;
	}
*/

        for ( dir = LEFT; dir <= DOWN; dir++ )
        {
            neigh_pos = pos;

            switch ( dir )
            {
                case LEFT:
                    neigh_pos.x--;
                    break;

                case RIGHT:
                    neigh_pos.x++;
                    break;

                case UP:
                    neigh_pos.y++;
                    break;

                case DOWN:
                    neigh_pos.y--;
                    break;

            }

            status = Tile( neigh_pos.x, neigh_pos.y ).type;

            if ( is_empty( status ) )
            {
                temp_len = Tile( neigh_pos.x, neigh_pos.y ).pathVal;

                if ( temp_len > len )
                {
                    Tile( neigh_pos.x, neigh_pos.y ).pathVal = len;
                    push( neigh_pos );
                }
            }

        }
    }

/****   Only for debugging   ***********
    for ( y = MEM_HEIGHT - 1; y >= 0; y-- )
    {
        for ( x = 0; x < MEM_WIDTH; x++ )
        {
            status = Tile( x, y ).type;
            printf("%c ", status );
        }
        printf("\n");
    }

    for ( y = MEM_HEIGHT - 1; y >= 0; y-- )
    {
        for ( x = 0; x < MEM_WIDTH; x++ )
        {
            len = Tile( x, y ).pathVal;
            if ( len > 999 )
            {
                len = 999;
            }
            printf("%3ld ", len );
        }
        printf("\n");
    }
****   Only for debugging   ***********/

}
